package sep.example.io;
import java.io.*;

public class rot14InputStream extends FilterInputStream {
  public rot14InputStream (InputStream i) {
    super(i);
  }

  public int read() throws IOException {
    return rot14(in.read());
  }

  public int read(byte[] data) throws IOException {
    for (int i = 0; i < data.length; i++) 
      data[i] = (byte) rot14(in.read());
    return -1;
  }

  private int rot14 (int c) {
    if( (c >= 'A') && (c <= 'Z') ) 
      c = (((c-'A') + 13)%26) + 'A';
    if( (c >= 'a') && (c <= 'z') )
      c = (((c-'a') + 13)%26) + 'a';
    return c;
  }
}

