package sep.example.net;

import java.net.*;
import java.io.*;
import java.util.*;

public class TinyHttpd {
  public static void main(String[] argv) throws IOException {
//    System.setSecurityManager(new TinyHttpdSecurityManager());
    ServerSocket ss = new ServerSocket(Integer.parseInt(argv[0]));
    while (true) 
      new TinyHttpdConnection(ss.accept());
  }
}

class TinyHttpdConnection extends Thread {
  Socket sock;
  TinyHttpdConnection(Socket s) {
    sock = s;
    setPriority(NORM_PRIORITY - 1);
    start();
  }

  public void run() {
    try {
      OutputStream out = sock.getOutputStream();
      String req = new DataInputStream(sock.getInputStream()).readLine();
      System.out.println("Request: " + req);
      StringTokenizer st = new StringTokenizer(req);
      if((st.countTokens() >= 2) && st.nextToken().equals("GET")) {
	if((req = st.nextToken()).startsWith("/")) 
	  req = req.substring(1);
	if( req.endsWith("/") || req.equals("")) 
	  req = req + "index.html";
	try {
	  FileInputStream fis = new FileInputStream(req);
	  byte[] data = new byte[fis.available()];

	  fis.read(data);

	  //	  FilterInputStream ris = new example.io.rot14InputStream(fis);
	  //          ris.read(data);

	  out.write(data);
	}
	catch(FileNotFoundException e) {
	  new PrintStream(out).println("404 Not Found");
	}
/*
	catch(SecurityException e) {
	  new PrintStream(out).println("403 Forbidden");
	}
*/
      } else
	new PrintStream(out).println("400 Bad Request");

      sock.close();
    }
    catch(IOException e) {
      System.out.println("I/O error " + e);
    }
  }
}
