package sep.io;

import  juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ArgumentKeeperTest {
  public static void main(String[] argv) {

    String[] args = {
      "-v", "par=parfile", "fileName0", "fileName1", "array=1,2,3", "float=2.1", "n1=1", "n2=2", "n3=3", "axis=12,.004f,0.0f,time,sec"
    };
    System.out.println("The argument list of the invocation is: ");
    System.out.println("   "+args[0]+" "+args[1]+" "+args[2]+" "+args[3]); 
    System.out.println("   "+args[4]+" "+args[5]+" "+args[6]+" "+args[7]);
    System.out.println("   "+args[8]+" "+args[9]);

    System.out.println("We create an Argumentable from a String array");
    ArgumentKeeper command = new ArgumentKeeper(args);

    // Testing of the result (testing should be grouped by object)
    boolean correct = true;

    System.out.println("We test argument flags");
    System.out.println("true      == " + command.containsKey("-v"));
    if (!command.containsKey("-v")) correct = false;

    System.out.println("We test paramenter statement par=parfile");
    // ArgumentKeeper is NOT yet recursivelyfollowing par=file
    System.out.println("true      == " + command.containsKey("par"));
    if (!command.containsKey("par")) correct = false;
    System.out.println("parfile   == " + command.get("par"));
    if (!command.get("par").equals("parfile")) correct = false;

    System.out.println("We test paramenter statement array=1,2,3");
    System.out.println("true      == " + command.containsKey("array"));
    if (!command.containsKey("array")) correct = false;

    int[] i = command.getIntArray("array"); 
    System.out.println("1   == " + i[0]);
    if (1 != i[0]) correct = false;
    System.out.println("2   == " + i[1]);
    if (2 != i[1]) correct = false;
    System.out.println("3   == " + i[2]);
    if (3 != i[2]) correct = false;

    System.out.println("We test paramenter statement deflt=4,5,6");
    System.out.println("false      == " + command.containsKey("deflt"));
    if ( command.containsKey("deflt")) correct = false;

    int[] j = command.getIntArray("deflt","4,5,6"); 
    System.out.println("4   == " + j[0]);
    if (4 != j[0]) correct = false;
    System.out.println("5   == " + j[1]);
    if (5 != j[1]) correct = false;
    System.out.println("6   == " + j[2]);
    if (6 != j[2]) correct = false;

    System.out.println("We test the listing of filenames");
    String[] files = command.getNames();
    System.out.println("fileName0 == " + files[0]);
    if (! files[0].equals("fileName0")) correct = false;
    System.out.println("fileName1 == " + files[1]);
    if (! files[1].equals("fileName1")) correct = false;
    
    System.out.println("We test paramenter statement float=2.1");
    System.out.println("true      == " + command.containsKey("float"));
    if (!command.containsKey("float")) correct = false;
    System.out.println("2.1   == " + command.getFloat("float"));
    if (command.getFloat("float") != 2.1f) correct = false;

    System.out.println("Number of parameter of type n1, n2, etc is 3: " + 
		       command.nOfParamWith("n"));
    if (command.nOfParamWith("n") != 3) correct =false; 

    rsf.vector.Axis ax = command.getAxis("axis");
    System.out.println("Axis: " + ax); 
    if (  ax.nsamples !=     12  ) correct =false; 
    if (  ax.delta    != 0.004f  ) correct =false; 
    if (  ax.offset   != 0.0f    ) correct =false; 
    if (! ax.label.equals("time")) correct =false; 
    if (! ax.unit.equals("sec")  ) correct =false; 

    Tester.exit(correct);
  }
}
