package sep.io;

import java.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DataKeeperTest {
  public static void main(String[] args) throws IOException {

    // Create a Data file (corresponding to the Header's "in") 
    String  inName = new String("junk1.H");
    String outName = new String("junk2.H");
    int size = 6;
    float[] outdata = {0.0F,0.5F,1.5F,2.0F,2.5F,3.0F};
    DataOutputStream dout = new     DataOutputStream(
                            new     FileOutputStream(
                            new                 File(inName)));
    for(int i=0; i < size; i++) {
      dout.writeFloat(outdata[i]);
    }
    dout.close();

    DataInputStream fin   = new DataInputStream(
			    new FileInputStream(inName));


    DataOutputStream fout  = new DataOutputStream(
			    new FileOutputStream(outName));

    DataKeeper data = new DataKeeper();
    data.read(fin,size,"float");

    float[] indata = new float[size]; 
    indata = (float[])data.getData();

    data.write(fout);

    fin.close();
    fout.close();

    DataInputStream ftst   = new DataInputStream(
			      new FileInputStream(outName));

    float[] tstdata = new float[size]; 
    for (int i=0; i < size; i++) {
      tstdata[i] = ftst.readFloat();
    }
    ftst.close();

    // Testing of the result (testing should be grouped by object)
    boolean correct = true;

    for(int i=0; i < size; i++) {
      System.out.println(
	      String.valueOf(outdata[i]) + " == " + 
              String.valueOf( indata[i]) + " == " + 
	      String.valueOf(tstdata[i])
	      );
      if (outdata[i] != indata[i] || outdata[i] != tstdata[i]) correct = false;
    }
    // Announce the result
    if( correct ){ 
      System.out.println("passes test");
      System.exit(0);
    } else {
      System.out.println("fails test");
      System.exit(1);
    }
  }
}
