package sep.io;

import java.util.*;
import java.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public abstract class IrregularData {
  private Hashtable dataSheet = new Hashtable();

  /**
   * read key into stream, recognize separator, 
   * read data into stream, recognize separator, etc
   */
  public void read(DataInputStream din) {
    System.out.println("IrregularData: read not implemented yet");
  }

  /**
   * write key  into stream, write  separator, 
   * write data into stream, write  separator, etc
   */
  public void write(DataOutputStream din) {
    System.out.println("IrregularData: write not implemented yet");
  }

  public Object getNearest(Object key) {
    return getNearest(key,1);
  }
  public Object getNearest(Object key, int number) {
    if (number != 1) {
      System.out.println("IrregularData: more Nearest neighbors not implemented yet");
    }
    // Object nearest  = (Object)(Class.forName(key)).newInstance();
    Enumeration e = dataSheet.keys();
    Object testKey = e.nextElement();
    Object nearest = testKey;
    float dist = getDistance(nearest, key);

    for ( ; e.hasMoreElements(); ) {
      testKey = e.nextElement();
      if (getDistance(testKey, key) < dist) {
	nearest = testKey;
	dist    = getDistance(testKey, key);
      }
/*
System.out.println("Key: " + key);
System.out.println("TestKey: " + testKey);
System.out.println("Distance: " + dist);
System.out.println("Nearest: " + nearest);	
System.out.println("");	
*/
    }
    return nearest; 
  }

  public abstract float getDistance(Object key1,Object key2);

  public boolean contains(Object value) {
    return dataSheet.contains(value);
  }
  public boolean containsKey(Object key) {
    return dataSheet.containsKey(key);
  }
  public Enumeration elements() {
    return dataSheet.elements();
  }
  public Object get(Object key) {
    return dataSheet.get(key);
  }
  public boolean isEmpty() {
    return dataSheet.isEmpty();
  } 
  public Enumeration keys() {
    return dataSheet.keys();
  }
  public Object put(Object key, Object value) {
    return dataSheet.put(key,value);
  }
  public Object remove(Object key) {
    return dataSheet.remove(key);
  }
  public int size() {
    return dataSheet.size();
  }

  public String toString() {
    return dataSheet.toString();
  }
}
