package sep.io;

import java.lang.Math;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class IrregularDataTest {

  public static void main(String[] args) {

    Galilee galilee = new Galilee();

    galilee.put(new Key(1,0.0F,0.1F), new Float( -23.3F));
    galilee.put(new Key(1,0.0F,2.1F), new Float( -53.2F));
    galilee.put(new Key(1,0.0F,5.1F), new Float(-203.1F));
    galilee.put(new Key(1,0.0F,5.2F), new Float(-203.3F));
    galilee.put(new Key(1,0.0F,6.8F), new Float(-221.3F));
    galilee.put(new Key(1,0.0F,7.1F), new Float(-189.2F));
    galilee.put(new Key(1,0.0F,8.0F), new Float(-101.3F));
    galilee.put(new Key(1,0.0F,8.5F), new Float( -49.3F));
    galilee.put(new Key(1,0.0F,9.1F), new Float(  -3.9F));

    galilee.put(new Key(2,1.4F,0.1F), new Float(  -2.3F));
    galilee.put(new Key(2,2.5F,0.1F), new Float( -13.2F));
    galilee.put(new Key(2,3.5F,0.2F), new Float( -12.1F));
    galilee.put(new Key(2,4.6F,0.3F), new Float( -53.3F));
    galilee.put(new Key(2,5.6F,0.3F), new Float(-101.3F));
    galilee.put(new Key(2,6.7F,0.4F), new Float( -88.2F));
    galilee.put(new Key(2,7.7F,0.4F), new Float( -54.3F));
    galilee.put(new Key(2,8.7F,0.5F), new Float( -42.3F));
    galilee.put(new Key(2,9.8F,0.6F), new Float( -12.9F));
    galilee.put(new Key(2,9.9F,0.7F), new Float(  -9.9F));

    galilee.put(new Key(3,0.4F,1.1F), new Float(  -1.3F));
    galilee.put(new Key(3,1.4F,2.1F), new Float( -23.2F));
    galilee.put(new Key(3,2.6F,3.4F), new Float( -54.3F));
    galilee.put(new Key(3,3.7F,4.5F), new Float( -32.3F));
    galilee.put(new Key(3,4.8F,5.6F), new Float( -11.8F));
    galilee.put(new Key(3,5.9F,6.7F), new Float(  -5.5F));



    Key wyTest = new Key(3,4.8F,5.6F);
    System.out.println(wyTest.hashCode());
    System.out.println("Value: " + galilee.containsKey(wyTest));
    galilee.put(wyTest, new Float( -1.3F));
    System.out.println("Value: " + galilee.containsKey(wyTest));
    System.out.println("Value: " + galilee.get(wyTest));

    Key myTest = new Key(3,4.8F,5.6F);
    System.out.println(myTest.hashCode());
    System.out.println("Value: " + galilee.containsKey(myTest));
    galilee.put(myTest, new Float(  1.3F));
    System.out.println("Value: " + galilee.containsKey(myTest));
    System.out.println("Value: " + galilee.get(myTest));

    System.out.println("Value: " + galilee.get(wyTest));
    System.out.println("Value: " + galilee.get(new Key(3,4.8F,5.6F)));

    Key lyTest = new Key(3,3.8F,2.6F);

    if (wyTest.hashCode() == myTest.hashCode()) 
      System.out.println("HashCode identical");
    if (wyTest.equals(myTest)) 
      System.out.println("Key equals");

    System.out.println("Dist: "    + galilee.getDistance(wyTest,myTest));

    System.out.println("Nearest: " + galilee.getNearest(myTest));

    System.out.println("Nearest: " + galilee.getNearest(lyTest));

    System.out.println("Size: "    + galilee.size());
  }
}

class Key {
  int track;
  float x;
  float y;
  public Key(int track, float x, float y) {
    this.track = track;
    this.x     = x;
    this.y     = y;
  }
  public int hashCode() {
    return (new Float( 2010196 * x + 1501197 * y + 1492 * track)).intValue();
  }
  public boolean equals(Object key) {
    if(x     == ((Key)key).getX() && 
       y     == ((Key)key).getY() && 
       track == ((Key)key).getTrack() ){
      return true;
    }
    else {
      return false;
    }
  }
  public float getX() {
    return x;
  }
  public float getY() {
    return y;
  }
  public int getTrack() {
    return track;
  }
}

class Galilee extends IrregularData {

  public float getDistance(Object key1,Object key2) {
    double x1 = new Double(((Key)key1).getX()).doubleValue();
    System.out.println("x1: " + x1);
    double x2 = new Double(((Key)key2).getX()).doubleValue();
    System.out.println("x2: " + x2);
    double y1 = new Double(((Key)key1).getY()).doubleValue();
    System.out.println("y1: " + y1);
    double y2 = new Double(((Key)key2).getY()).doubleValue();
    System.out.println("y2: " + y2);
    double dist   = Math.sqrt((x1 - y1) * (x1 - y1) + (x2 - y2) * (x2 - y2));
    return new Double(dist).floatValue();
  }
}


