package sep.io;

import java.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ParaKeeperTest {
  public static void main(String[] args) throws IOException {

    // Create a Para file (corresponding to the Header's "in") 
    String  inName = new String("junk1.H");
    String outName = new String("junk2.H");
    PrintWriter pout = new PrintWriter(
                       new FileOutputStream(
                       new File(inName)));
    pout.println("in=junky.H");
    //pout.println("in=" + '"' + "./junk.H@" + '"');
    pout.println("o1=0.0 d1=3.5 n1=3 label1=distance unit=km"); 
    pout.println("o1=1.5 n2=2 n3=1 d3=10 d2=3.1 o2=-34 o3=121");
    pout.println('\004'); //This signals the end of the header file
    pout.println("n1=2"); //This should be invisible to the header

    pout.close();

    DataInputStream fin   = new DataInputStream(
                            new FileInputStream(inName));

    PrintStream     fout  = new PrintStream(
                            new FileOutputStream(outName));

    ParaKeeper para = new ParaKeeper();
    para.read(fin);

    para.in();

    System.out.println(para.toString());
    para.write(fout);

    fin.close();
    fout.close();

    // Testing of the result (testing should be grouped by object)
    boolean correct = true;

    // Compare the output's header values with the input's
    int n1        = para.getInt("n1");
    float o1      = para.getFloat("o1");
    String label1 = para.getString("label1");

    System.out.println("Header comparison:");
    System.out.println(n1     + " == 3"       );
    System.out.println(o1     + " == 1.5"     );
    System.out.println(label1 + " == distance");
    
    if (n1     !=   3     )          correct = false;
    if (o1     != 1.5F    )          correct = false;
    if (! label1.equals("distance")) correct = false;

    System.out.println("Look at junk2.H");

    // Announce the result
    if( correct ){ 
      System.out.println("passes test");
      System.exit(0);
    } else {
      System.out.println("fails test");
      System.exit(1);
    }
  }
}



