package sep.io;

import java.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class RegularDataTest {
  public static void main(String[] args) throws IOException {

    // Create a Header file
    String fileName = new String("junk.H");
    PrintStream fout = new      PrintStream( 
                       new FileOutputStream(
		       new             File(fileName)));
    //fout.println("in=" + '"' + "./junk.H@" + '"');
    fout.println("o1=0.0 d1=3.5 n1=25 label1=distance unit=km"); 
    fout.println("o1=1.5 d1=0.5  n1=3                         ");
    fout.println("o2=2.0 d2=1.0  n2=2 n3=1                    ");
    fout.println("in=stdin");
    fout.print('\014');
    fout.print('\014');
    fout.print('\004');

    // Reset the stream and Create the Data part 
    DataOutputStream dout = new DataOutputStream(fout); 

    int size = 6;
    float[] outdata = {0.0F,0.5F,1.5F,2.0F,2.5F,3.0F};
    //    DataOutputStream dout = new     DataOutputStream(
    //                            new     FileOutputStream(
    //                            new                 File(dataName)));

    //dout.writeChar('\014');
    //dout.writeChar('\014');
    for(int i=0; i < size; i++) {
      dout.writeFloat(outdata[i]);
    }
    dout.close();

    //Start testing:
    
    /*    DataInputStream fin = new DataInputStream(
		          new FileInputStream(
		          new File(fileName)));

    RegularData myData = new RegularData();
    myData.read(fin);
    */

    RegularData myData = new RegularData( fileName);
    String fileName2 = "junkjunk.H";
    DataOutputStream jout   = new DataOutputStream(
			      new FileOutputStream(fileName2));
    myData.write(jout);

    // Testing of the result (testing should be grouped by object)
    boolean correct = true;

    // Compare the output's header values with the input's
    int n1        = myData.getInt("n1");
    float o1      = myData.getFloat("o1");
    String label1 = myData.getString("label1");

    System.out.println("Header comparison:");
    System.out.println(n1     + " == 3"       );
    System.out.println(o1     + " == 1.5"     );
    System.out.println(label1 + " == distance");
    
    if (n1     !=   3     )          correct = false;
    if (o1     != 1.5F    )          correct = false;
    if (! label1.equals("distance")) correct = false;

    // Compare the data output with the data input
    float[] indata = new float[size]; 
    indata = (float[])myData.getData();

    System.out.println("Data comparison:");
    for(int i=0; i < size; i++) {
      System.out.println(
	      String.valueOf(outdata[i]) + " == " + 
              String.valueOf( indata[i])
	      );
      if (outdata[i] != indata[i]) correct = false;
    }

    // Announce the result
    if( correct ){ 
      System.out.println("passes test");
      System.exit(0);
    } else {
      System.out.println("fails test");
      System.exit(1);
    }
  }
}
